﻿using System;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using System.Diagnostics;

namespace LogonShell
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            Mutex mutex = new System.Threading.Mutex(false, "ClassicLogonShell");
            try
            {
                if (mutex.WaitOne(0, false))
                {
                    Settings.Initialize(args);
                    if (Settings.Read(28).ToLower() != "classic")
                        Application.EnableVisualStyles();
                    if (!(args.Length > 0 && args[0] == "/quiet"))
                        Application.Run(new BackgroundForm(args));
                }
                else
                {
                    // MessageBox.Show("An instance of the application is already running.");  Do Nothing
                }
            }
            finally
            {
                if (mutex != null)
                {
                    mutex.Close();
                }
            }
        }
    }
}
