﻿using LogonShellCustom.Properties;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LogonShellCustom
{
    public partial class MainWindow : Form
    {

        [DllImport("uxtheme.dll", SetLastError = true)]
        static extern int SetWindowTheme(IntPtr window, string app, string theme);

		List<string> ControlsList = new List<string>(new string[]
        {
			"labelTitle",
			"buttonOK",
			"buttonCancel",
			"buttonOptions",
			"buttonShutdown",
			"labelPassword",
			"labelUsername"
		});
		List<int> SettingsList = new List<int>(new int[]
		{
			-1,
			-1,
			-1,
			-1,
			-1,
			-1,
			-1
		});
		System.Windows.Forms.Control UsernameBox;
		private GifImage gifImage = null;
		string[] actionDescriptions = new string[3];
		string[] actionIcons = new string[3];
		public MainWindow()
        {
            InitializeComponent();
			ReloadMainPanel();

		}

        private void MainWindow_Load(object sender, EventArgs e)
        {
            SetWindowTheme(Handle, " ", " ");
        }
		private void ReloadMainPanel()
		{
			int index = comboBox1.SelectedIndex;
			foreach (Control item in MainPanel.Controls)
				item.Visible = false;
			SettingsList.Clear();
			for (int i = 0; i < ControlsList.Count; i++)
				SettingsList.Add(-1);
			var labels = MainPanel.Controls.OfType<Label>();
			var buttons = MainPanel.Controls.OfType<Button>();
			pictureBoxBackground.Visible = true;
			pictureBoxXIcon.Image = null;
			pictureBoxXIcon.BackColor = SystemColors.Control;
			comboBoxUsername.Items.Clear();
			comboBoxUsername.SelectedIndexChanged -= comboBoxshutdown_SelectedIndexChanged;
			if (index > -1 && index < 5)
			{
				if (index != 2 && index != 4)
				{
					gifImage = new GifImage(Settings.Read(19));
					gifImage.ReverseAtEnd = Boolean.Parse(Settings.Read(20));
					pictureBoxLoading.Image = gifImage.GetNextFrame();
				} else
					pictureBoxLoading.Image = Image.FromFile(Settings.Read(19));
				pictureBoxBanner.Image = Image.FromFile(Settings.Read(3));
				pictureBoxLoading.Visible = true;
				pictureBoxBanner.Visible = true;
				if (Settings.Read(27).ToLower() != "default")
				{
					this.BackColor = ColorTranslator.FromHtml(Settings.Read(27));
					foreach (var lbl in labels)
						lbl.BackColor = ColorTranslator.FromHtml(Settings.Read(27));
					foreach (var btn in buttons)
						btn.BackColor = SystemColors.Control;
				}
				if (Settings.Read(26).ToLower() != "default")
				{
					foreach (var lbl in labels)
						lbl.ForeColor = ColorTranslator.FromHtml(Settings.Read(26));
				}
			}
			if (index == 0)
			{
				pictureBoxBackground.Image = Resources.Logon;
				textBoxPassword.Visible = true;
				if (Boolean.Parse(Settings.Read(17)))
					buttonCancel.Enabled = true;
				else
					buttonCancel.Enabled = false;
				comboBoxUsername.Location = new Point(92, 138);
				comboBoxUsername.Width = 242;
				comboBoxUsername.DropDownStyle = ComboBoxStyle.DropDown;
				var usernameOption = Settings.Read(16);
				switch (usernameOption)
				{
					case "Simple":
						textBoxUsername.Visible = true;
						comboBoxUsername.Visible = false;
						this.ActiveControl = textBoxUsername;
						textBoxUsername.Focus();
						UsernameBox = textBoxUsername;
						break;
					case "Last":
						textBoxUsername.Visible = true;
						comboBoxUsername.Visible = false;
						comboBoxUsername.Text = "Last Logged-In User";
						UsernameBox = textBoxUsername;
						this.ActiveControl = textBoxPassword;
						textBoxPassword.Focus();
						break;
					case "List":
						textBoxUsername.Visible = false;
						comboBoxUsername.Visible = true;
						comboBoxUsername.Items.AddRange(new string[] { "Last Logged-In User", "Other User" });
						this.ActiveControl = comboBoxUsername;
						comboBoxUsername.Focus();
						UsernameBox = comboBoxUsername;
						break;
					case "ListLast":
						textBoxUsername.Visible = false;
						comboBoxUsername.Visible = true;
						comboBoxUsername.Items.AddRange(new string[] { "Last Logged-In User", "Other User" });
						comboBoxUsername.Text = "Last Logged-In User";
						UsernameBox = comboBoxUsername;
						this.ActiveControl = textBoxPassword;
						textBoxPassword.Focus();
						break;
					default:
						MessageBox.Show("Configuration Error: unknown login type " + usernameOption);
						break;
				}
				SettingsList.Insert(0, 5);
				SettingsList.Insert(1, 1);
				SettingsList.Insert(2, 2);
				SettingsList.Insert(3, 8);
				SettingsList.Insert(4, 9);
				SettingsList.Insert(5, 6);
				SettingsList.Insert(6, 7);
				SettingsList.Insert(7, 5);
				pictureBoxXIcon.Location = new Point(395, 10);
				pictureBoxXIcon.Size = new Rectangle(0, 0, 20, 18).Size;
				pictureBoxXIcon.Visible = true;
				pictureBoxXIcon.Image = null;
				pictureBoxXIcon.BackColor = SystemColors.ActiveCaption;
				if (Settings.Read(18).ToLower() == "enabled")
					pictureBoxXIcon.Image = Resources.iconx;
				else if (Settings.Read(18).ToLower() == "disabled")
					pictureBoxXIcon.Image = Resources.disabledx;
			}
			if (index == 1)
			{
				pictureBoxBackground.Image = Resources.KeySequence;
				SettingsList.Insert(0, 5);
			}
			if (index == 2)
			{
				pictureBoxBackground.Image = Resources.Loading;
			}
			if (index == 3)
			{
				comboBoxUsername.Location = new Point(74, 163);
				comboBoxUsername.Width = 260;
				comboBoxUsername.DropDownStyle = ComboBoxStyle.DropDownList;
				comboBoxUsername.Visible = true;
				comboBoxUsername.Items.Add(Settings.Read(15, true));
				comboBoxUsername.Items.Add(Settings.Read(16, true));
				comboBoxUsername.Items.Add(Settings.Read(17, true));
				actionDescriptions[0] = Settings.Read(18, true);
				actionDescriptions[1] = Settings.Read(19, true);
				actionDescriptions[2] = Settings.Read(20, true);
				actionIcons[0] = Settings.Read(21);
				actionIcons[1] = Settings.Read(29);
				actionIcons[2] = Settings.Read(30);
				comboBoxUsername.SelectedIndex = 0;
				comboBoxUsername.SelectedIndexChanged += comboBoxshutdown_SelectedIndexChanged;
                pictureBoxBackground.Image = Resources.Shutdown;
                SettingsList.Insert(1, 1);
                SettingsList.Insert(2, 2);
                pictureBoxXIcon.Location = new Point(20, 152);
                pictureBoxXIcon.Size = new Rectangle(0, 0, 32, 32).Size;
                pictureBoxXIcon.Visible = true;
            }
			if (index == 4)
			{
				pictureBoxBackground.Image = Resources.Loading;
			}
			if (index == 5)
			{
				pictureBoxBackground.Image = Resources.Error;
				SettingsList.Insert(1, 1);
			}
			if (index == 6)
			{
				pictureBoxBackground.Image = Resources.Prompt;
				SettingsList.Insert(1, 1);
			}
			foreach (var lbl in labels)
				if (ControlsList.Contains(lbl.Name) && SettingsList.ElementAt(ControlsList.IndexOf(lbl.Name)) != -1)
				{
					lbl.Text = Settings.Read(SettingsList.ElementAt(ControlsList.IndexOf(lbl.Name)), true);
					lbl.Visible = true;
				}
			foreach (var btn in buttons)
				if (ControlsList.Contains(btn.Name) && SettingsList.ElementAt(ControlsList.IndexOf(btn.Name)) != -1)
				{
					btn.Text = Settings.Read(SettingsList.ElementAt(ControlsList.IndexOf(btn.Name)), true);
					btn.Visible = true;
				}
			if (SettingsList.ElementAt(3) == 8)
				buttonOptions.Text = buttonOptions.Text + " < <";
		}

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
			ReloadMainPanel();
		}

		private void comboBoxshutdown_SelectedIndexChanged(object sender, EventArgs e)
		{
			ReloadMainPanel();
		}

		private void contextMenuStripUniv_Opening(object sender, CancelEventArgs e)
		{
			contextMenuStripUniv.Items.Clear();
			Control source = contextMenuStripUniv.SourceControl;
			if (source != null)
			{
				ToolStripMenuItem tsi = new ToolStripMenuItem();
				tsi.Text = source.Name;
				tsi.Click += StripItemClicked;
				contextMenuStripUniv.Items.Add(tsi);
			}
		}

		private void StripItemClicked(object sender, EventArgs e)
		{
			if (contextMenuStripUniv.SourceControl != null && ControlsList.Contains(contextMenuStripUniv.SourceControl.Name) && SettingsList.ElementAt(ControlsList.IndexOf(contextMenuStripUniv.SourceControl.Name)) != -1)
			{
				var dialog = new TextBoxForm(Settings.Read(SettingsList.ElementAt(ControlsList.IndexOf(contextMenuStripUniv.SourceControl.Name)), true));
				var result = dialog.ShowDialog();
				if (result == DialogResult.OK)
                {
					Settings.Write(SettingsList.ElementAt(ControlsList.IndexOf(contextMenuStripUniv.SourceControl.Name)), dialog.textBox1.Text, true);
					ReloadMainPanel();
				}
				dialog.Dispose();
			}
		}
	}
}
