﻿using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Security.Principal;
using System.Threading;
using System.Windows.Forms;

namespace LogonShellCustom
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            IniFile settings = new IniFile(Settings.Default);
            if (!File.Exists(settings.Path) || (settings.KeyExists(1) && Boolean.Parse(settings.Read(1))))
                settings.Reset();
            else if (!settings.KeyExists(0) || settings.Read(0) != Settings.ProgramVersion)
                settings.Update();
            IniFile Locale = new IniFile(Settings.Locale, settings.Read(4));
            if (settings.KeyExists(2) && Boolean.Parse(settings.Read(2)) || !File.Exists(Locale.Path))
                Locale.Reset();
            else if (!Locale.KeyExists(0) || Locale.Read(0) != Settings.ProgramVersion)
                Locale.Update();
            Settings.Initialize(args);
            Application.Run(new MainWindow());
        }
    }
}
