﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LogonShellCustomizer
{
    public partial class Form5 : Form
    {
        public static IniKey[] Default { get; } = new IniKey[] {
            new IniKey("UseKeySequence", "False", "KeySequence"),
            new IniKey("Type", "ListLast", "Login"),
            new IniKey("IsCancelEnabled", "True", "Login"),
            new IniKey("ButtonX", "None", "Login"),
            new IniKey("Hint", "TryFirst", "Login")
        };
        public string file;
        IniFile Settings;
        public Form5(string file)
        {
            InitializeComponent();
            this.file = file;
            if (!File.Exists(file))
                File.Copy("LogonShell.ini", file);
            Settings = new IniFile(Default, file);
            loadSettings();
        }

        private void loadSettings()
        {
            switch(Settings.Read(0).ToLower())
            {
                case "false":
                    checkBox1.Checked = false;
                    comboBox1.SelectedIndex = 0;
                    comboBox1.Enabled = false;
                    break;
                case "win":
                    checkBox1.Checked = true;
                    comboBox1.SelectedIndex = 0;
                    break;
                case "ctrlaltwin":
                    checkBox1.Checked = true;
                    comboBox1.SelectedIndex = 1;
                    break;
                case "ctrlaltesc":
                    checkBox1.Checked = true;
                    comboBox1.SelectedIndex = 2;
                    break;
            }
            switch (Settings.Read(1).ToLower())
            {
                case "simple":
                    comboBox2.SelectedIndex = 0;
                    break;
                case "last":
                    comboBox2.SelectedIndex = 1;
                    break;
                case "list":
                    comboBox2.SelectedIndex = 2;
                    break;
                case "listlast":
                    comboBox2.SelectedIndex = 3;
                    break;
            }
            checkBox2.Checked = Boolean.Parse(Settings.Read(2));
            switch (Settings.Read(3).ToLower())
            {
                case "none":
                    comboBox3.SelectedIndex = 0;
                    break;
                case "disabled":
                    comboBox3.SelectedIndex = 1;
                    break;
                case "enabled":
                    comboBox3.SelectedIndex = 2;
                    break;
            }
            switch (Settings.Read(4).ToLower())
            {
                case "never":
                    comboBox4.SelectedIndex = 0;
                    break;
                case "always":
                    comboBox4.SelectedIndex = 1;
                    break;
                case "tryfirst":
                    comboBox4.SelectedIndex = 2;
                    break;
            }

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
                comboBox1.Enabled = true;
            else
                comboBox1.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!checkBox1.Checked)
                Settings.Write(0, "False");
            else
                switch (comboBox1.SelectedIndex)
                {
                    case 0:
                        Settings.Write(0, "Win");
                        break;
                    case 1:
                        Settings.Write(0, "CtrlAltWin");
                        break;
                    case 2:
                        Settings.Write(0, "CtrlAltEsc");
                        break;
                }
            switch (comboBox2.SelectedIndex)
            {
                case 0:
                    Settings.Write(1, "Simple");
                    break;
                case 1:
                    Settings.Write(1, "Last");
                    break;
                case 2:
                    Settings.Write(1, "List");
                    break;
                case 3:
                    Settings.Write(1, "ListLast");
                    break;
            }
            if (checkBox2.Checked)
                Settings.Write(2, "True");
            else
                Settings.Write(2, "False");
            switch (comboBox3.SelectedIndex)
            {
                case 0:
                    Settings.Write(3, "None");
                    break;
                case 1:
                    Settings.Write(3, "Disabled");
                    break;
                case 2:
                    Settings.Write(3, "Enabled");
                    break;
            }
            switch (comboBox4.SelectedIndex)
            {
                case 0:
                    Settings.Write(4, "Never");
                    break;
                case 1:
                    Settings.Write(4, "Always");
                    break;
                case 2:
                    Settings.Write(4, "TryFirst");
                    break;
            }
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            File.Copy("LogonShell.ini", file, true);
            loadSettings();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            File.Delete(file);
            this.Close();
        }
    }
}
